%global goipath github.com/prometheus/pushgateway

Summary:        Prometheus pushgateway.
Name:           pushgateway
Version:        1.6.2
Release:        2%{?dist}
License:        Apache-2.0
URL:            https://github.com/prometheus/%{name}
Source0:        https://github.com/prometheus/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:        pushgateway.service
Source2:        pushgateway.default
# execute 'go mod vendor' under the source code path can generator vendor package
Source3:        %{name}-%{version}-vendor.tar.gz

BuildRequires:  golang >= 1.19 go-rpm-macros
BuildRequires:  promu systemd
%{?systemd_requires}
Requires(pre):  shadow-utils

%description
The Prometheus Pushgateway exists to allow ephemeral and batch jobs to expose their metrics to Prometheus.
Since these kinds of jobs may not exist long enough to be scraped, they can instead push their metrics to a Pushgateway.
The Pushgateway then exposes these metrics to Prometheus.

%prep
%autosetup -p1 -n %{name}-%{version}
%setup -T -D -a 3 -n %{name}-%{version}

%build
export GOPATH=$PWD/.gopath
mkdir -p ${GOPATH}/src/github.com/prometheus
ln -sfn $PWD $GOPATH/src/%{goipath}
export CGO_ENABLED=0
export GOFLAGS="-mod=vendor"
%gobuild -o bin/%{name} %{goipath}

%install
install -Dpm 755 bin/%{name} %{buildroot}%{_bindir}/%{name}
install -d %{buildroot}%{_sharedstatedir}/prometheus/pushgateway
install -Dpm 644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service
install -Dpm 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/default/%{name}

%pre
getent group prometheus >/dev/null || groupadd -r prometheus
getent passwd prometheus >/dev/null || \
  useradd -r -g prometheus -d %{_sharedstatedir}/prometheus -s /sbin/nologin \
          -c "Prometheus services" prometheus
exit 0

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun %{name}.service

%files
%license LICENSE
%doc CHANGELOG.md CODE_OF_CONDUCT.md CONTRIBUTING.md MAINTAINERS.md README.md SECURITY.md
%{_unitdir}/%{name}.service
%config(noreplace) %{_sysconfdir}/default/%{name}
%dir %attr(755, prometheus, prometheus)%{_sharedstatedir}/prometheus/pushgateway
%{_bindir}/*

%changelog
* Tue Apr 23 2024 jackeyji <jackeyji@tencent.com> - 1.6.2-2
- [Type] bugfix
- [DESC] fix conflict with prometheus installation directory

* Tue Sep 12 2023 jackeyji <jackeyji@tencent.com> - 1.6.2-1
- initial build
